<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.5"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>DayZExpansion: DayzExpansion/Core/Scripts/3_game/dayzexpansion_core/math/transform.c Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../doxygen_light.png"/></td>
  <td id="projectalign">
   <div id="projectname">DayZExpansion<span id="projectnumber">&#160;1.7.12</span>
   </div>
   <div id="projectbrief">DayZExpansion Script Documentation Courtecy of P4K1TZ</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.5 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "../../search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(document).ready(function(){initNavTree('d8/d27/transform_8c_source.html','../../'); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="headertitle"><div class="title">transform.c</div></div>
</div><!--header-->
<div class="contents">
<a href="../../d8/d27/transform_8c.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="comment">/**</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span><span class="comment"> * Transform.c</span></div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="comment"> *</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span><span class="comment"> * DayZ Expansion Mod</span></div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="comment"> * www.dayzexpansion.com</span></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span><span class="comment"> * © 2022 DayZ Expansion Mod Team</span></div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span><span class="comment"> *</span></div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span><span class="comment"> * This work is licensed under the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International License.</span></div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span><span class="comment"> * To view a copy of this license, visit http://creativecommons.org/licenses/by-nc-nd/4.0/.</span></div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="comment"> *</span></div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="comment"> */</span></div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span> </div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html">   13</a></span><span class="keyword">class </span><a class="code hl_class" href="../../dd/db7/class_transform.html">Transform</a> <span class="comment">// also known as Matrix4</span></div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span>{</div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">   15</a></span>    vector <a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[4];</div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno">   16</span> </div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#a9d0855fac958b2f492a19eb9c54b6d46">   17</a></span>    ref <a class="code hl_class" href="../../d9/dca/class_matrix3.html">Matrix3</a> <a class="code hl_variable" href="../../dd/db7/class_transform.html#a9d0855fac958b2f492a19eb9c54b6d46">m_basis</a>;</div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#a358e968b5e077e6040f197d36ea6c169">   18</a></span>    ref <a class="code hl_class" href="../../dc/de3/class_quaternion.html">Quaternion</a> <a class="code hl_variable" href="../../dd/db7/class_transform.html#a358e968b5e077e6040f197d36ea6c169">m_rotation</a>;</div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno">   19</span> </div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#a3f2bc6009877be0f8a03c500f1732e49">   20</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../dd/db7/class_transform.html#a3f2bc6009877be0f8a03c500f1732e49">Transform</a>()</div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno">   21</span>    {</div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span>        <a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a> = {<span class="stringliteral">&quot;1 0 0&quot;</span>, <span class="stringliteral">&quot;0 1 0&quot;</span>, <span class="stringliteral">&quot;0 1 0&quot;</span>, <span class="stringliteral">&quot;0 0 0&quot;</span>};</div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno">   23</span> </div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span>        <a class="code hl_variable" href="../../dd/db7/class_transform.html#a9d0855fac958b2f492a19eb9c54b6d46">m_basis</a> = <span class="keyword">new</span> <a class="code hl_class" href="../../d9/dca/class_matrix3.html">Matrix3</a>;</div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno">   25</span>        <a class="code hl_variable" href="../../dd/db7/class_transform.html#a358e968b5e077e6040f197d36ea6c169">m_rotation</a> = <span class="keyword">new</span> <a class="code hl_class" href="../../dc/de3/class_quaternion.html">Quaternion</a>;</div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno">   26</span>        <a class="code hl_variable" href="../../dd/db7/class_transform.html#a9d0855fac958b2f492a19eb9c54b6d46">m_basis</a>.<a class="code hl_variable" href="../../d9/dca/class_matrix3.html#afa212c2ede422da5b0a728c116bd174a">m_trans</a> = <span class="keyword">this</span>;</div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span>        <a class="code hl_variable" href="../../dd/db7/class_transform.html#a358e968b5e077e6040f197d36ea6c169">m_rotation</a>.<a class="code hl_variable" href="../../dc/de3/class_quaternion.html#ac4601a46ee540902ccb0cda905386d49">m_trans</a> = <span class="keyword">this</span>;</div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span> </div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span>        <a class="code hl_function" href="../../dd/db7/class_transform.html#a25f51f2d7dbf82a15627b5d17864b87e">UpdateUnion</a>();</div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span>    }</div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span> </div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#a3a696ae6c5b78970e4d13c0b693f20b7">   32</a></span>    <a class="code hl_class" href="../../dd/db7/class_transform.html">Transform</a> <a class="code hl_function" href="../../dd/db7/class_transform.html#a3a696ae6c5b78970e4d13c0b693f20b7">Clone</a>()</div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span>    {</div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span>        <a class="code hl_class" href="../../dd/db7/class_transform.html">Transform</a> n = <span class="keyword">new</span> <a class="code hl_function" href="../../dd/db7/class_transform.html#a3f2bc6009877be0f8a03c500f1732e49">Transform</a>();</div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno">   35</span> </div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span>        n.<a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a> = <a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>;</div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span>        n.<a class="code hl_function" href="../../dd/db7/class_transform.html#a25f51f2d7dbf82a15627b5d17864b87e">UpdateUnion</a>();</div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span> </div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span>        <span class="keywordflow">return</span> n;</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span>    }</div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span> </div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#a060c6f1272e06d2e874f25b040f8657f">   42</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../dd/db7/class_transform.html#a060c6f1272e06d2e874f25b040f8657f">Debug</a>()</div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span>    {</div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span>        Print(<span class="stringliteral">&quot;Transform::Debug&quot;</span>);</div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span>        Print(<span class="stringliteral">&quot;[0] &quot;</span> + <a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[0]);</div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span>        Print(<span class="stringliteral">&quot;[1] &quot;</span> + <a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[1]);</div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span>        Print(<span class="stringliteral">&quot;[2] &quot;</span> + <a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[2]);</div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno">   48</span>        Print(<span class="stringliteral">&quot;[3] &quot;</span> + <a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[3]);</div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span>    }</div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span> </div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#a3dde3f1d2b1f62d2e163d399952be7dc">   51</a></span>    <a class="code hl_class" href="../../dd/db7/class_transform.html">Transform</a> <a class="code hl_function" href="../../dd/db7/class_transform.html#a3dde3f1d2b1f62d2e163d399952be7dc">Add</a>(<a class="code hl_class" href="../../dd/db7/class_transform.html">Transform</a> transform)</div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span>    {</div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span>        <span class="keywordflow">return</span> NULL;</div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span>    }</div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span> </div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#a81b0992739cfbe2a00f136664688fe81">   56</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../dd/db7/class_transform.html#a81b0992739cfbe2a00f136664688fe81">Set</a>(<span class="keywordtype">int</span> _index, vector _value)</div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span>    {</div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span>        <a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[_index] = _value;</div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span>    }</div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span> </div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#a9bc87107e6cf255408295398d6c3f188">   61</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../dd/db7/class_transform.html#a9bc87107e6cf255408295398d6c3f188">Set</a>(<span class="keywordtype">int</span> _index, <span class="keywordtype">string</span> _value)</div>
<div class="line"><a id="l00062" name="l00062"></a><span class="lineno">   62</span>    {</div>
<div class="line"><a id="l00063" name="l00063"></a><span class="lineno">   63</span>        <a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[_index] = _value.ToVector();</div>
<div class="line"><a id="l00064" name="l00064"></a><span class="lineno">   64</span>    }</div>
<div class="line"><a id="l00065" name="l00065"></a><span class="lineno">   65</span> </div>
<div class="line"><a id="l00066" name="l00066"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#a1472e181cdff0a0ec13aa184688dbc68">   66</a></span>    vector <a class="code hl_function" href="../../dd/db7/class_transform.html#a1472e181cdff0a0ec13aa184688dbc68">Get</a>(<span class="keywordtype">int</span> _index)</div>
<div class="line"><a id="l00067" name="l00067"></a><span class="lineno">   67</span>    {</div>
<div class="line"><a id="l00068" name="l00068"></a><span class="lineno">   68</span>        <span class="keywordflow">return</span> <a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[_index];</div>
<div class="line"><a id="l00069" name="l00069"></a><span class="lineno">   69</span>    }</div>
<div class="line"><a id="l00070" name="l00070"></a><span class="lineno">   70</span> </div>
<div class="line"><a id="l00071" name="l00071"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#a46bccab8937e4089b7ea674b2ca7d5a9">   71</a></span>    <a class="code hl_class" href="../../dd/db7/class_transform.html">Transform</a> <a class="code hl_function" href="../../dd/db7/class_transform.html#a46bccab8937e4089b7ea674b2ca7d5a9">Set</a>(notnull Object obj, <span class="keywordtype">bool</span> update = <span class="keyword">false</span>)</div>
<div class="line"><a id="l00072" name="l00072"></a><span class="lineno">   72</span>    {</div>
<div class="line"><a id="l00073" name="l00073"></a><span class="lineno">   73</span>        obj.SetTransform(<a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>);</div>
<div class="line"><a id="l00074" name="l00074"></a><span class="lineno">   74</span> </div>
<div class="line"><a id="l00075" name="l00075"></a><span class="lineno">   75</span>        <span class="keywordflow">if</span> (update)</div>
<div class="line"><a id="l00076" name="l00076"></a><span class="lineno">   76</span>        {</div>
<div class="line"><a id="l00077" name="l00077"></a><span class="lineno">   77</span>            obj.Update();</div>
<div class="line"><a id="l00078" name="l00078"></a><span class="lineno">   78</span>        }</div>
<div class="line"><a id="l00079" name="l00079"></a><span class="lineno">   79</span> </div>
<div class="line"><a id="l00080" name="l00080"></a><span class="lineno">   80</span>        <span class="keywordflow">return</span> <span class="keyword">this</span>;</div>
<div class="line"><a id="l00081" name="l00081"></a><span class="lineno">   81</span>    }</div>
<div class="line"><a id="l00082" name="l00082"></a><span class="lineno">   82</span> </div>
<div class="line"><a id="l00083" name="l00083"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#ad27fa76b54fc5628d6e132c8ec42e269">   83</a></span>    <a class="code hl_class" href="../../dd/db7/class_transform.html">Transform</a> <a class="code hl_function" href="../../dd/db7/class_transform.html#ad27fa76b54fc5628d6e132c8ec42e269">Get</a>(notnull Object obj)</div>
<div class="line"><a id="l00084" name="l00084"></a><span class="lineno">   84</span>    {</div>
<div class="line"><a id="l00085" name="l00085"></a><span class="lineno">   85</span>        obj.GetTransform(<a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>);</div>
<div class="line"><a id="l00086" name="l00086"></a><span class="lineno">   86</span> </div>
<div class="line"><a id="l00087" name="l00087"></a><span class="lineno">   87</span>        <a class="code hl_function" href="../../dd/db7/class_transform.html#a25f51f2d7dbf82a15627b5d17864b87e">UpdateUnion</a>();</div>
<div class="line"><a id="l00088" name="l00088"></a><span class="lineno">   88</span> </div>
<div class="line"><a id="l00089" name="l00089"></a><span class="lineno">   89</span>        <span class="keywordflow">return</span> <span class="keyword">this</span>;</div>
<div class="line"><a id="l00090" name="l00090"></a><span class="lineno">   90</span>    }</div>
<div class="line"><a id="l00091" name="l00091"></a><span class="lineno">   91</span> </div>
<div class="line"><a id="l00092" name="l00092"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#aebb00b9320f0d25f374dc4612472fb67">   92</a></span>    <span class="keyword">static</span> <a class="code hl_class" href="../../dd/db7/class_transform.html">Transform</a> <a class="code hl_function" href="../../dd/db7/class_transform.html#aebb00b9320f0d25f374dc4612472fb67">GetArray</a>(vector trans[4])</div>
<div class="line"><a id="l00093" name="l00093"></a><span class="lineno">   93</span>    {</div>
<div class="line"><a id="l00094" name="l00094"></a><span class="lineno">   94</span>        <a class="code hl_class" href="../../dd/db7/class_transform.html">Transform</a> n = <span class="keyword">new</span> <a class="code hl_function" href="../../dd/db7/class_transform.html#a3f2bc6009877be0f8a03c500f1732e49">Transform</a>();</div>
<div class="line"><a id="l00095" name="l00095"></a><span class="lineno">   95</span> </div>
<div class="line"><a id="l00096" name="l00096"></a><span class="lineno">   96</span>        n.<a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[0] = trans[0];</div>
<div class="line"><a id="l00097" name="l00097"></a><span class="lineno">   97</span>        n.<a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[1] = trans[1];</div>
<div class="line"><a id="l00098" name="l00098"></a><span class="lineno">   98</span>        n.<a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[2] = trans[2];</div>
<div class="line"><a id="l00099" name="l00099"></a><span class="lineno">   99</span>        n.<a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[3] = trans[3];</div>
<div class="line"><a id="l00100" name="l00100"></a><span class="lineno">  100</span> </div>
<div class="line"><a id="l00101" name="l00101"></a><span class="lineno">  101</span>        n.<a class="code hl_function" href="../../dd/db7/class_transform.html#a25f51f2d7dbf82a15627b5d17864b87e">UpdateUnion</a>();</div>
<div class="line"><a id="l00102" name="l00102"></a><span class="lineno">  102</span> </div>
<div class="line"><a id="l00103" name="l00103"></a><span class="lineno">  103</span>        <span class="keywordflow">return</span> n;</div>
<div class="line"><a id="l00104" name="l00104"></a><span class="lineno">  104</span>    }</div>
<div class="line"><a id="l00105" name="l00105"></a><span class="lineno">  105</span> </div>
<div class="line"><a id="l00106" name="l00106"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#a32152c5716454858545c5161dffd5558">  106</a></span>    <span class="keyword">static</span> <a class="code hl_class" href="../../dd/db7/class_transform.html">Transform</a> <a class="code hl_function" href="../../dd/db7/class_transform.html#a32152c5716454858545c5161dffd5558">GetObject</a>(notnull Object obj)</div>
<div class="line"><a id="l00107" name="l00107"></a><span class="lineno">  107</span>    {</div>
<div class="line"><a id="l00108" name="l00108"></a><span class="lineno">  108</span>        <a class="code hl_class" href="../../dd/db7/class_transform.html">Transform</a> n = <span class="keyword">new</span> <a class="code hl_function" href="../../dd/db7/class_transform.html#a3f2bc6009877be0f8a03c500f1732e49">Transform</a>();</div>
<div class="line"><a id="l00109" name="l00109"></a><span class="lineno">  109</span> </div>
<div class="line"><a id="l00110" name="l00110"></a><span class="lineno">  110</span>        n.<a class="code hl_function" href="../../dd/db7/class_transform.html#a1472e181cdff0a0ec13aa184688dbc68">Get</a>(obj);</div>
<div class="line"><a id="l00111" name="l00111"></a><span class="lineno">  111</span> </div>
<div class="line"><a id="l00112" name="l00112"></a><span class="lineno">  112</span>        <span class="keywordflow">return</span> n;</div>
<div class="line"><a id="l00113" name="l00113"></a><span class="lineno">  113</span>    }</div>
<div class="line"><a id="l00114" name="l00114"></a><span class="lineno">  114</span> </div>
<div class="line"><a id="l00115" name="l00115"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#ac0dccb98fbf4d9093c48c3338dbeaa06">  115</a></span>    <span class="keyword">static</span> <a class="code hl_class" href="../../dd/db7/class_transform.html">Transform</a> <a class="code hl_function" href="../../dd/db7/class_transform.html#ac0dccb98fbf4d9093c48c3338dbeaa06">GetPlayerBoneWS</a>(notnull Human human, <span class="keywordtype">int</span> boneIdx, <span class="keywordtype">int</span> mode = 0)</div>
<div class="line"><a id="l00116" name="l00116"></a><span class="lineno">  116</span>    {</div>
<div class="line"><a id="l00117" name="l00117"></a><span class="lineno">  117</span>        <a class="code hl_class" href="../../dd/db7/class_transform.html">Transform</a> n = <span class="keyword">new</span> <a class="code hl_function" href="../../dd/db7/class_transform.html#a3f2bc6009877be0f8a03c500f1732e49">Transform</a>();</div>
<div class="line"><a id="l00118" name="l00118"></a><span class="lineno">  118</span> </div>
<div class="line"><a id="l00119" name="l00119"></a><span class="lineno">  119</span>        human.GetBoneTransformWS(boneIdx, n.<a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>);</div>
<div class="line"><a id="l00120" name="l00120"></a><span class="lineno">  120</span>        <span class="keywordflow">if</span> (mode == 1)</div>
<div class="line"><a id="l00121" name="l00121"></a><span class="lineno">  121</span>        {</div>
<div class="line"><a id="l00122" name="l00122"></a><span class="lineno">  122</span>            n.<a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[0] = <span class="stringliteral">&quot;1 0 0&quot;</span>;</div>
<div class="line"><a id="l00123" name="l00123"></a><span class="lineno">  123</span>            n.<a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[1] = <span class="stringliteral">&quot;0 1 0&quot;</span>;</div>
<div class="line"><a id="l00124" name="l00124"></a><span class="lineno">  124</span>            n.<a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[2] = <span class="stringliteral">&quot;0 0 1&quot;</span>;</div>
<div class="line"><a id="l00125" name="l00125"></a><span class="lineno">  125</span>        }</div>
<div class="line"><a id="l00126" name="l00126"></a><span class="lineno">  126</span>        <span class="keywordflow">else</span> <span class="keywordflow">if</span> (mode == 2)</div>
<div class="line"><a id="l00127" name="l00127"></a><span class="lineno">  127</span>        {</div>
<div class="line"><a id="l00128" name="l00128"></a><span class="lineno">  128</span>            n.<a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[3] = <span class="stringliteral">&quot;0 0 0&quot;</span>;</div>
<div class="line"><a id="l00129" name="l00129"></a><span class="lineno">  129</span>        }</div>
<div class="line"><a id="l00130" name="l00130"></a><span class="lineno">  130</span> </div>
<div class="line"><a id="l00131" name="l00131"></a><span class="lineno">  131</span>        n.<a class="code hl_function" href="../../dd/db7/class_transform.html#a25f51f2d7dbf82a15627b5d17864b87e">UpdateUnion</a>();</div>
<div class="line"><a id="l00132" name="l00132"></a><span class="lineno">  132</span> </div>
<div class="line"><a id="l00133" name="l00133"></a><span class="lineno">  133</span>        <span class="keywordflow">return</span> n;</div>
<div class="line"><a id="l00134" name="l00134"></a><span class="lineno">  134</span>    }</div>
<div class="line"><a id="l00135" name="l00135"></a><span class="lineno">  135</span> </div>
<div class="line"><a id="l00136" name="l00136"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#a3320953fc35da5abdee7b6e6a46dd69f">  136</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../dd/db7/class_transform.html#a3320953fc35da5abdee7b6e6a46dd69f">Set</a>(notnull Object obj, <a class="code hl_class" href="../../dd/db7/class_transform.html">Transform</a> trans)</div>
<div class="line"><a id="l00137" name="l00137"></a><span class="lineno">  137</span>    {</div>
<div class="line"><a id="l00138" name="l00138"></a><span class="lineno">  138</span>        trans.<a class="code hl_function" href="../../dd/db7/class_transform.html#a81b0992739cfbe2a00f136664688fe81">Set</a>(obj);</div>
<div class="line"><a id="l00139" name="l00139"></a><span class="lineno">  139</span>    }</div>
<div class="line"><a id="l00140" name="l00140"></a><span class="lineno">  140</span> </div>
<div class="line"><a id="l00141" name="l00141"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#a5b3ebf5f6efdd1e5d668fdefe84cdb16">  141</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../dd/db7/class_transform.html#a5b3ebf5f6efdd1e5d668fdefe84cdb16">UpdateBasis</a>()</div>
<div class="line"><a id="l00142" name="l00142"></a><span class="lineno">  142</span>    {</div>
<div class="line"><a id="l00143" name="l00143"></a><span class="lineno">  143</span>        <a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[0] = <a class="code hl_variable" href="../../dd/db7/class_transform.html#a9d0855fac958b2f492a19eb9c54b6d46">m_basis</a>.<a class="code hl_variable" href="../../d9/dca/class_matrix3.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0];</div>
<div class="line"><a id="l00144" name="l00144"></a><span class="lineno">  144</span>        <a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[1] = <a class="code hl_variable" href="../../dd/db7/class_transform.html#a9d0855fac958b2f492a19eb9c54b6d46">m_basis</a>.<a class="code hl_variable" href="../../d9/dca/class_matrix3.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1];</div>
<div class="line"><a id="l00145" name="l00145"></a><span class="lineno">  145</span>        <a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[2] = <a class="code hl_variable" href="../../dd/db7/class_transform.html#a9d0855fac958b2f492a19eb9c54b6d46">m_basis</a>.<a class="code hl_variable" href="../../d9/dca/class_matrix3.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2];</div>
<div class="line"><a id="l00146" name="l00146"></a><span class="lineno">  146</span> </div>
<div class="line"><a id="l00147" name="l00147"></a><span class="lineno">  147</span>        Math3D.MatrixToQuat(<a class="code hl_variable" href="../../dd/db7/class_transform.html#a9d0855fac958b2f492a19eb9c54b6d46">m_basis</a>.<a class="code hl_variable" href="../../d9/dca/class_matrix3.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>, <a class="code hl_variable" href="../../dd/db7/class_transform.html#a358e968b5e077e6040f197d36ea6c169">m_rotation</a>.<a class="code hl_variable" href="../../dc/de3/class_quaternion.html#a727473a1ed1f49125865f71bb5adfd6d">data</a>);</div>
<div class="line"><a id="l00148" name="l00148"></a><span class="lineno">  148</span>    }</div>
<div class="line"><a id="l00149" name="l00149"></a><span class="lineno">  149</span> </div>
<div class="line"><a id="l00150" name="l00150"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#a89f6d9f8e5feea833d901f2699e4beef">  150</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../dd/db7/class_transform.html#a89f6d9f8e5feea833d901f2699e4beef">UpdateRotation</a>()</div>
<div class="line"><a id="l00151" name="l00151"></a><span class="lineno">  151</span>    {</div>
<div class="line"><a id="l00152" name="l00152"></a><span class="lineno">  152</span>        Math3D.QuatToMatrix(<a class="code hl_variable" href="../../dd/db7/class_transform.html#a358e968b5e077e6040f197d36ea6c169">m_rotation</a>.<a class="code hl_variable" href="../../dc/de3/class_quaternion.html#a727473a1ed1f49125865f71bb5adfd6d">data</a>, <a class="code hl_variable" href="../../dd/db7/class_transform.html#a9d0855fac958b2f492a19eb9c54b6d46">m_basis</a>.<a class="code hl_variable" href="../../d9/dca/class_matrix3.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>);</div>
<div class="line"><a id="l00153" name="l00153"></a><span class="lineno">  153</span> </div>
<div class="line"><a id="l00154" name="l00154"></a><span class="lineno">  154</span>        <a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[0] = <a class="code hl_variable" href="../../dd/db7/class_transform.html#a9d0855fac958b2f492a19eb9c54b6d46">m_basis</a>.<a class="code hl_variable" href="../../d9/dca/class_matrix3.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0];</div>
<div class="line"><a id="l00155" name="l00155"></a><span class="lineno">  155</span>        <a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[1] = <a class="code hl_variable" href="../../dd/db7/class_transform.html#a9d0855fac958b2f492a19eb9c54b6d46">m_basis</a>.<a class="code hl_variable" href="../../d9/dca/class_matrix3.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1];</div>
<div class="line"><a id="l00156" name="l00156"></a><span class="lineno">  156</span>        <a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[2] = <a class="code hl_variable" href="../../dd/db7/class_transform.html#a9d0855fac958b2f492a19eb9c54b6d46">m_basis</a>.<a class="code hl_variable" href="../../d9/dca/class_matrix3.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2];</div>
<div class="line"><a id="l00157" name="l00157"></a><span class="lineno">  157</span>    }</div>
<div class="line"><a id="l00158" name="l00158"></a><span class="lineno">  158</span> </div>
<div class="line"><a id="l00159" name="l00159"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#a25f51f2d7dbf82a15627b5d17864b87e">  159</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../dd/db7/class_transform.html#a25f51f2d7dbf82a15627b5d17864b87e">UpdateUnion</a>()</div>
<div class="line"><a id="l00160" name="l00160"></a><span class="lineno">  160</span>    {</div>
<div class="line"><a id="l00161" name="l00161"></a><span class="lineno">  161</span>        <a class="code hl_variable" href="../../dd/db7/class_transform.html#a9d0855fac958b2f492a19eb9c54b6d46">m_basis</a>.<a class="code hl_variable" href="../../d9/dca/class_matrix3.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[0] = <a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[0];</div>
<div class="line"><a id="l00162" name="l00162"></a><span class="lineno">  162</span>        <a class="code hl_variable" href="../../dd/db7/class_transform.html#a9d0855fac958b2f492a19eb9c54b6d46">m_basis</a>.<a class="code hl_variable" href="../../d9/dca/class_matrix3.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[1] = <a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[1];</div>
<div class="line"><a id="l00163" name="l00163"></a><span class="lineno">  163</span>        <a class="code hl_variable" href="../../dd/db7/class_transform.html#a9d0855fac958b2f492a19eb9c54b6d46">m_basis</a>.<a class="code hl_variable" href="../../d9/dca/class_matrix3.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>[2] = <a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[2];</div>
<div class="line"><a id="l00164" name="l00164"></a><span class="lineno">  164</span> </div>
<div class="line"><a id="l00165" name="l00165"></a><span class="lineno">  165</span>        Math3D.MatrixToQuat(<a class="code hl_variable" href="../../dd/db7/class_transform.html#a9d0855fac958b2f492a19eb9c54b6d46">m_basis</a>.<a class="code hl_variable" href="../../d9/dca/class_matrix3.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>, <a class="code hl_variable" href="../../dd/db7/class_transform.html#a358e968b5e077e6040f197d36ea6c169">m_rotation</a>.<a class="code hl_variable" href="../../dc/de3/class_quaternion.html#a727473a1ed1f49125865f71bb5adfd6d">data</a>);</div>
<div class="line"><a id="l00166" name="l00166"></a><span class="lineno">  166</span>    }</div>
<div class="line"><a id="l00167" name="l00167"></a><span class="lineno">  167</span> </div>
<div class="line"><a id="l00168" name="l00168"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#a9a939488083d62cd09a23880ed43e469">  168</a></span>    <a class="code hl_class" href="../../d9/dca/class_matrix3.html">Matrix3</a> <a class="code hl_function" href="../../dd/db7/class_transform.html#a9a939488083d62cd09a23880ed43e469">GetBasis</a>()</div>
<div class="line"><a id="l00169" name="l00169"></a><span class="lineno">  169</span>    {</div>
<div class="line"><a id="l00170" name="l00170"></a><span class="lineno">  170</span>        <span class="keywordflow">return</span> <a class="code hl_variable" href="../../dd/db7/class_transform.html#a9d0855fac958b2f492a19eb9c54b6d46">m_basis</a>;</div>
<div class="line"><a id="l00171" name="l00171"></a><span class="lineno">  171</span>    }</div>
<div class="line"><a id="l00172" name="l00172"></a><span class="lineno">  172</span> </div>
<div class="line"><a id="l00173" name="l00173"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#ac840f87478c54108bc21f037e677c724">  173</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../dd/db7/class_transform.html#ac840f87478c54108bc21f037e677c724">SetBasis</a>(<a class="code hl_class" href="../../d9/dca/class_matrix3.html">Matrix3</a> basis)</div>
<div class="line"><a id="l00174" name="l00174"></a><span class="lineno">  174</span>    {</div>
<div class="line"><a id="l00175" name="l00175"></a><span class="lineno">  175</span>        <a class="code hl_variable" href="../../dd/db7/class_transform.html#a9d0855fac958b2f492a19eb9c54b6d46">m_basis</a> = basis;</div>
<div class="line"><a id="l00176" name="l00176"></a><span class="lineno">  176</span>        <a class="code hl_variable" href="../../dd/db7/class_transform.html#a9d0855fac958b2f492a19eb9c54b6d46">m_basis</a>.<a class="code hl_variable" href="../../d9/dca/class_matrix3.html#afa212c2ede422da5b0a728c116bd174a">m_trans</a> = <span class="keyword">this</span>;</div>
<div class="line"><a id="l00177" name="l00177"></a><span class="lineno">  177</span> </div>
<div class="line"><a id="l00178" name="l00178"></a><span class="lineno">  178</span>        <a class="code hl_function" href="../../dd/db7/class_transform.html#a5b3ebf5f6efdd1e5d668fdefe84cdb16">UpdateBasis</a>();</div>
<div class="line"><a id="l00179" name="l00179"></a><span class="lineno">  179</span>    }</div>
<div class="line"><a id="l00180" name="l00180"></a><span class="lineno">  180</span> </div>
<div class="line"><a id="l00181" name="l00181"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#a73ebc268bc3bc7f6174e80a62775f601">  181</a></span>    <a class="code hl_class" href="../../dc/de3/class_quaternion.html">Quaternion</a> <a class="code hl_function" href="../../dd/db7/class_transform.html#a73ebc268bc3bc7f6174e80a62775f601">GetRotation</a>()</div>
<div class="line"><a id="l00182" name="l00182"></a><span class="lineno">  182</span>    {</div>
<div class="line"><a id="l00183" name="l00183"></a><span class="lineno">  183</span>        <span class="keywordflow">return</span> <a class="code hl_variable" href="../../dd/db7/class_transform.html#a358e968b5e077e6040f197d36ea6c169">m_rotation</a>;</div>
<div class="line"><a id="l00184" name="l00184"></a><span class="lineno">  184</span>    }</div>
<div class="line"><a id="l00185" name="l00185"></a><span class="lineno">  185</span> </div>
<div class="line"><a id="l00186" name="l00186"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#a4fc2ed0760e58284bde2bce512e3f5a9">  186</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../dd/db7/class_transform.html#a4fc2ed0760e58284bde2bce512e3f5a9">SetRotation</a>(<a class="code hl_class" href="../../dc/de3/class_quaternion.html">Quaternion</a> rotation)</div>
<div class="line"><a id="l00187" name="l00187"></a><span class="lineno">  187</span>    {</div>
<div class="line"><a id="l00188" name="l00188"></a><span class="lineno">  188</span>        <a class="code hl_variable" href="../../dd/db7/class_transform.html#a358e968b5e077e6040f197d36ea6c169">m_rotation</a> = rotation;</div>
<div class="line"><a id="l00189" name="l00189"></a><span class="lineno">  189</span>        <a class="code hl_variable" href="../../dd/db7/class_transform.html#a358e968b5e077e6040f197d36ea6c169">m_rotation</a>.<a class="code hl_variable" href="../../dc/de3/class_quaternion.html#ac4601a46ee540902ccb0cda905386d49">m_trans</a> = <span class="keyword">this</span>;</div>
<div class="line"><a id="l00190" name="l00190"></a><span class="lineno">  190</span> </div>
<div class="line"><a id="l00191" name="l00191"></a><span class="lineno">  191</span>        <a class="code hl_function" href="../../dd/db7/class_transform.html#a89f6d9f8e5feea833d901f2699e4beef">UpdateRotation</a>();</div>
<div class="line"><a id="l00192" name="l00192"></a><span class="lineno">  192</span>    }</div>
<div class="line"><a id="l00193" name="l00193"></a><span class="lineno">  193</span> </div>
<div class="line"><a id="l00194" name="l00194"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#aa2522dc780d64c32197f11d1fb65005a">  194</a></span>    vector <a class="code hl_function" href="../../dd/db7/class_transform.html#aa2522dc780d64c32197f11d1fb65005a">GetYawPitchRoll</a>()</div>
<div class="line"><a id="l00195" name="l00195"></a><span class="lineno">  195</span>    {</div>
<div class="line"><a id="l00196" name="l00196"></a><span class="lineno">  196</span>        <span class="keywordflow">return</span> <a class="code hl_variable" href="../../dd/db7/class_transform.html#a9d0855fac958b2f492a19eb9c54b6d46">m_basis</a>.<a class="code hl_function" href="../../d9/dca/class_matrix3.html#a5aae8ad2dd2184243fe842bc1b1391a4">ToYawPitchRoll</a>();</div>
<div class="line"><a id="l00197" name="l00197"></a><span class="lineno">  197</span>    }</div>
<div class="line"><a id="l00198" name="l00198"></a><span class="lineno">  198</span> </div>
<div class="line"><a id="l00199" name="l00199"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#a6693b4561288db5578eff106112cb5a4">  199</a></span>    vector <a class="code hl_function" href="../../dd/db7/class_transform.html#a6693b4561288db5578eff106112cb5a4">GetOrigin</a>()</div>
<div class="line"><a id="l00200" name="l00200"></a><span class="lineno">  200</span>    {</div>
<div class="line"><a id="l00201" name="l00201"></a><span class="lineno">  201</span>        <span class="keywordflow">return</span> <a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[3];</div>
<div class="line"><a id="l00202" name="l00202"></a><span class="lineno">  202</span>    }</div>
<div class="line"><a id="l00203" name="l00203"></a><span class="lineno">  203</span> </div>
<div class="line"><a id="l00204" name="l00204"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#a76414760f23ef03d6a251caceef7d656">  204</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../dd/db7/class_transform.html#a76414760f23ef03d6a251caceef7d656">SetOrigin</a>(vector origin)</div>
<div class="line"><a id="l00205" name="l00205"></a><span class="lineno">  205</span>    {</div>
<div class="line"><a id="l00206" name="l00206"></a><span class="lineno">  206</span>        <a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[3] = origin;</div>
<div class="line"><a id="l00207" name="l00207"></a><span class="lineno">  207</span>    }</div>
<div class="line"><a id="l00208" name="l00208"></a><span class="lineno">  208</span> </div>
<div class="line"><a id="l00209" name="l00209"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#a53c66828897f63bf5519da52bda90b64">  209</a></span>    <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code hl_function" href="../../dd/db7/class_transform.html#a53c66828897f63bf5519da52bda90b64">DirectionAndUp</a>(vector dir, vector up, out <a class="code hl_class" href="../../dd/db7/class_transform.html">Transform</a> trans, vector pos = <span class="stringliteral">&quot;0 0 0&quot;</span>)</div>
<div class="line"><a id="l00210" name="l00210"></a><span class="lineno">  210</span>    {</div>
<div class="line"><a id="l00211" name="l00211"></a><span class="lineno">  211</span>        <span class="keywordflow">if</span> (trans == NULL)</div>
<div class="line"><a id="l00212" name="l00212"></a><span class="lineno">  212</span>            trans = <span class="keyword">new</span> <a class="code hl_function" href="../../dd/db7/class_transform.html#a3f2bc6009877be0f8a03c500f1732e49">Transform</a>;</div>
<div class="line"><a id="l00213" name="l00213"></a><span class="lineno">  213</span> </div>
<div class="line"><a id="l00214" name="l00214"></a><span class="lineno">  214</span>        Math3D.DirectionAndUpMatrix(dir, up, trans.data);</div>
<div class="line"><a id="l00215" name="l00215"></a><span class="lineno">  215</span>        trans.UpdateUnion();</div>
<div class="line"><a id="l00216" name="l00216"></a><span class="lineno">  216</span> </div>
<div class="line"><a id="l00217" name="l00217"></a><span class="lineno">  217</span>        trans.data[3] = pos;</div>
<div class="line"><a id="l00218" name="l00218"></a><span class="lineno">  218</span>    }</div>
<div class="line"><a id="l00219" name="l00219"></a><span class="lineno">  219</span> </div>
<div class="line"><a id="l00220" name="l00220"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#a0df668f1a18a1c1b559074c96b20b7ea">  220</a></span>    vector <a class="code hl_function" href="../../dd/db7/class_transform.html#a0df668f1a18a1c1b559074c96b20b7ea">Transform</a>(vector v)</div>
<div class="line"><a id="l00221" name="l00221"></a><span class="lineno">  221</span>    {</div>
<div class="line"><a id="l00222" name="l00222"></a><span class="lineno">  222</span>        vector n = vector.Zero;</div>
<div class="line"><a id="l00223" name="l00223"></a><span class="lineno">  223</span> </div>
<div class="line"><a id="l00224" name="l00224"></a><span class="lineno">  224</span>        n[0] = vector.Dot(<a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[0], v) + <a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[3][0];</div>
<div class="line"><a id="l00225" name="l00225"></a><span class="lineno">  225</span>        n[1] = vector.Dot(<a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[1], v) + <a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[3][1];</div>
<div class="line"><a id="l00226" name="l00226"></a><span class="lineno">  226</span>        n[2] = vector.Dot(<a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[2], v) + <a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[3][2];</div>
<div class="line"><a id="l00227" name="l00227"></a><span class="lineno">  227</span> </div>
<div class="line"><a id="l00228" name="l00228"></a><span class="lineno">  228</span>        <span class="keywordflow">return</span> n;</div>
<div class="line"><a id="l00229" name="l00229"></a><span class="lineno">  229</span>    }</div>
<div class="line"><a id="l00230" name="l00230"></a><span class="lineno">  230</span> </div>
<div class="line"><a id="l00231" name="l00231"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#af474b26ca40a8835eeff58cebc300ca7">  231</a></span>    <span class="keyword">static</span> <a class="code hl_class" href="../../dd/db7/class_transform.html">Transform</a> <a class="code hl_function" href="../../dd/db7/class_transform.html#af474b26ca40a8835eeff58cebc300ca7">YawPitchRoll</a>(vector ypr, vector pos = <span class="stringliteral">&quot;0 0 0&quot;</span>)</div>
<div class="line"><a id="l00232" name="l00232"></a><span class="lineno">  232</span>    {</div>
<div class="line"><a id="l00233" name="l00233"></a><span class="lineno">  233</span>        <a class="code hl_class" href="../../dd/db7/class_transform.html">Transform</a> trans = <span class="keyword">new</span> <a class="code hl_function" href="../../dd/db7/class_transform.html#a3f2bc6009877be0f8a03c500f1732e49">Transform</a>;</div>
<div class="line"><a id="l00234" name="l00234"></a><span class="lineno">  234</span> </div>
<div class="line"><a id="l00235" name="l00235"></a><span class="lineno">  235</span>        Math3D.YawPitchRollMatrix(ypr, trans.<a class="code hl_variable" href="../../dd/db7/class_transform.html#a9d0855fac958b2f492a19eb9c54b6d46">m_basis</a>.<a class="code hl_variable" href="../../d9/dca/class_matrix3.html#a91e02ed005a7e173a36504fc5e5f4fa9">data</a>);</div>
<div class="line"><a id="l00236" name="l00236"></a><span class="lineno">  236</span> </div>
<div class="line"><a id="l00237" name="l00237"></a><span class="lineno">  237</span>        trans.<a class="code hl_function" href="../../dd/db7/class_transform.html#a5b3ebf5f6efdd1e5d668fdefe84cdb16">UpdateBasis</a>();</div>
<div class="line"><a id="l00238" name="l00238"></a><span class="lineno">  238</span> </div>
<div class="line"><a id="l00239" name="l00239"></a><span class="lineno">  239</span>        trans.<a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[3] = pos;</div>
<div class="line"><a id="l00240" name="l00240"></a><span class="lineno">  240</span> </div>
<div class="line"><a id="l00241" name="l00241"></a><span class="lineno">  241</span>        <span class="keywordflow">return</span> trans;</div>
<div class="line"><a id="l00242" name="l00242"></a><span class="lineno">  242</span>    }</div>
<div class="line"><a id="l00243" name="l00243"></a><span class="lineno">  243</span> </div>
<div class="line"><a id="l00244" name="l00244"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#a74e3f86d689a8642ca78cff6fc852bfe">  244</a></span>    <a class="code hl_class" href="../../dd/db7/class_transform.html">Transform</a> <a class="code hl_function" href="../../dd/db7/class_transform.html#a74e3f86d689a8642ca78cff6fc852bfe">Multiply</a>(<a class="code hl_class" href="../../dd/db7/class_transform.html">Transform</a> m)</div>
<div class="line"><a id="l00245" name="l00245"></a><span class="lineno">  245</span>    {</div>
<div class="line"><a id="l00246" name="l00246"></a><span class="lineno">  246</span>        <a class="code hl_class" href="../../dd/db7/class_transform.html">Transform</a> n = <span class="keyword">new</span> <a class="code hl_function" href="../../dd/db7/class_transform.html#a3f2bc6009877be0f8a03c500f1732e49">Transform</a>;</div>
<div class="line"><a id="l00247" name="l00247"></a><span class="lineno">  247</span> </div>
<div class="line"><a id="l00248" name="l00248"></a><span class="lineno">  248</span>        Math3D.MatrixMultiply4(<a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>, m.<a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>, n.<a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>);</div>
<div class="line"><a id="l00249" name="l00249"></a><span class="lineno">  249</span> </div>
<div class="line"><a id="l00250" name="l00250"></a><span class="lineno">  250</span>        <span class="keywordflow">return</span> n;</div>
<div class="line"><a id="l00251" name="l00251"></a><span class="lineno">  251</span>    }</div>
<div class="line"><a id="l00252" name="l00252"></a><span class="lineno">  252</span> </div>
<div class="line"><a id="l00253" name="l00253"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#ae8acbadb0be0e88d11577d8695718010">  253</a></span>    <a class="code hl_class" href="../../dd/db7/class_transform.html">Transform</a> <a class="code hl_function" href="../../dd/db7/class_transform.html#ae8acbadb0be0e88d11577d8695718010">InvMultiply</a>(<a class="code hl_class" href="../../dd/db7/class_transform.html">Transform</a> m)</div>
<div class="line"><a id="l00254" name="l00254"></a><span class="lineno">  254</span>    {</div>
<div class="line"><a id="l00255" name="l00255"></a><span class="lineno">  255</span>        <a class="code hl_class" href="../../dd/db7/class_transform.html">Transform</a> n = <span class="keyword">new</span> <a class="code hl_function" href="../../dd/db7/class_transform.html#a3f2bc6009877be0f8a03c500f1732e49">Transform</a>;</div>
<div class="line"><a id="l00256" name="l00256"></a><span class="lineno">  256</span> </div>
<div class="line"><a id="l00257" name="l00257"></a><span class="lineno">  257</span>        Math3D.MatrixInvMultiply4(<a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>, m.<a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>, n.<a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>);</div>
<div class="line"><a id="l00258" name="l00258"></a><span class="lineno">  258</span> </div>
<div class="line"><a id="l00259" name="l00259"></a><span class="lineno">  259</span>        <span class="keywordflow">return</span> n;</div>
<div class="line"><a id="l00260" name="l00260"></a><span class="lineno">  260</span>    }</div>
<div class="line"><a id="l00261" name="l00261"></a><span class="lineno">  261</span> </div>
<div class="line"><a id="l00262" name="l00262"></a><span class="lineno"><a class="line" href="../../dd/db7/class_transform.html#a2df926c756e933af6b0991e872acd5b0">  262</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="../../dd/db7/class_transform.html#a2df926c756e933af6b0991e872acd5b0">CopyTo</a>(out vector mat[4])</div>
<div class="line"><a id="l00263" name="l00263"></a><span class="lineno">  263</span>    {</div>
<div class="line"><a id="l00264" name="l00264"></a><span class="lineno">  264</span>        mat[0] = <a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[0];</div>
<div class="line"><a id="l00265" name="l00265"></a><span class="lineno">  265</span>        mat[1] = <a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[1];</div>
<div class="line"><a id="l00266" name="l00266"></a><span class="lineno">  266</span>        mat[2] = <a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[2];</div>
<div class="line"><a id="l00267" name="l00267"></a><span class="lineno">  267</span>        mat[3] = <a class="code hl_variable" href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">data</a>[3];</div>
<div class="line"><a id="l00268" name="l00268"></a><span class="lineno">  268</span>    }</div>
<div class="line"><a id="l00269" name="l00269"></a><span class="lineno">  269</span>};</div>
<div class="ttc" id="aclass_matrix3_html"><div class="ttname"><a href="../../d9/dca/class_matrix3.html">Matrix3</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d03/matrix3_8c_source.html#l00013">matrix3.c:14</a></div></div>
<div class="ttc" id="aclass_matrix3_html_a5aae8ad2dd2184243fe842bc1b1391a4"><div class="ttname"><a href="../../d9/dca/class_matrix3.html#a5aae8ad2dd2184243fe842bc1b1391a4">Matrix3::ToYawPitchRoll</a></div><div class="ttdeci">vector ToYawPitchRoll()</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d03/matrix3_8c_source.html#l00227">matrix3.c:227</a></div></div>
<div class="ttc" id="aclass_matrix3_html_a91e02ed005a7e173a36504fc5e5f4fa9"><div class="ttname"><a href="../../d9/dca/class_matrix3.html#a91e02ed005a7e173a36504fc5e5f4fa9">Matrix3::data</a></div><div class="ttdeci">vector data[3]</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d03/matrix3_8c_source.html#l00015">matrix3.c:15</a></div></div>
<div class="ttc" id="aclass_matrix3_html_afa212c2ede422da5b0a728c116bd174a"><div class="ttname"><a href="../../d9/dca/class_matrix3.html#afa212c2ede422da5b0a728c116bd174a">Matrix3::m_trans</a></div><div class="ttdeci">Transform m_trans</div><div class="ttdef"><b>Definition:</b> <a href="../../d0/d03/matrix3_8c_source.html#l00017">matrix3.c:17</a></div></div>
<div class="ttc" id="aclass_quaternion_html"><div class="ttname"><a href="../../dc/de3/class_quaternion.html">Quaternion</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d9d/quaternion_8c_source.html#l00013">quaternion.c:14</a></div></div>
<div class="ttc" id="aclass_quaternion_html_a727473a1ed1f49125865f71bb5adfd6d"><div class="ttname"><a href="../../dc/de3/class_quaternion.html#a727473a1ed1f49125865f71bb5adfd6d">Quaternion::data</a></div><div class="ttdeci">float data[4]</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d9d/quaternion_8c_source.html#l00015">quaternion.c:15</a></div></div>
<div class="ttc" id="aclass_quaternion_html_ac4601a46ee540902ccb0cda905386d49"><div class="ttname"><a href="../../dc/de3/class_quaternion.html#ac4601a46ee540902ccb0cda905386d49">Quaternion::m_trans</a></div><div class="ttdeci">Transform m_trans</div><div class="ttdef"><b>Definition:</b> <a href="../../d5/d9d/quaternion_8c_source.html#l00017">quaternion.c:17</a></div></div>
<div class="ttc" id="aclass_transform_html"><div class="ttname"><a href="../../dd/db7/class_transform.html">Transform</a></div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00013">transform.c:14</a></div></div>
<div class="ttc" id="aclass_transform_html_a060c6f1272e06d2e874f25b040f8657f"><div class="ttname"><a href="../../dd/db7/class_transform.html#a060c6f1272e06d2e874f25b040f8657f">Transform::Debug</a></div><div class="ttdeci">void Debug()</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00042">transform.c:42</a></div></div>
<div class="ttc" id="aclass_transform_html_a0df668f1a18a1c1b559074c96b20b7ea"><div class="ttname"><a href="../../dd/db7/class_transform.html#a0df668f1a18a1c1b559074c96b20b7ea">Transform::Transform</a></div><div class="ttdeci">vector Transform(vector v)</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00220">transform.c:220</a></div></div>
<div class="ttc" id="aclass_transform_html_a1472e181cdff0a0ec13aa184688dbc68"><div class="ttname"><a href="../../dd/db7/class_transform.html#a1472e181cdff0a0ec13aa184688dbc68">Transform::Get</a></div><div class="ttdeci">vector Get(int _index)</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00066">transform.c:66</a></div></div>
<div class="ttc" id="aclass_transform_html_a25f51f2d7dbf82a15627b5d17864b87e"><div class="ttname"><a href="../../dd/db7/class_transform.html#a25f51f2d7dbf82a15627b5d17864b87e">Transform::UpdateUnion</a></div><div class="ttdeci">void UpdateUnion()</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00159">transform.c:159</a></div></div>
<div class="ttc" id="aclass_transform_html_a2df926c756e933af6b0991e872acd5b0"><div class="ttname"><a href="../../dd/db7/class_transform.html#a2df926c756e933af6b0991e872acd5b0">Transform::CopyTo</a></div><div class="ttdeci">void CopyTo(out vector mat[4])</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00262">transform.c:262</a></div></div>
<div class="ttc" id="aclass_transform_html_a32152c5716454858545c5161dffd5558"><div class="ttname"><a href="../../dd/db7/class_transform.html#a32152c5716454858545c5161dffd5558">Transform::GetObject</a></div><div class="ttdeci">static Transform GetObject(notnull Object obj)</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00106">transform.c:106</a></div></div>
<div class="ttc" id="aclass_transform_html_a3320953fc35da5abdee7b6e6a46dd69f"><div class="ttname"><a href="../../dd/db7/class_transform.html#a3320953fc35da5abdee7b6e6a46dd69f">Transform::Set</a></div><div class="ttdeci">static void Set(notnull Object obj, Transform trans)</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00136">transform.c:136</a></div></div>
<div class="ttc" id="aclass_transform_html_a358e968b5e077e6040f197d36ea6c169"><div class="ttname"><a href="../../dd/db7/class_transform.html#a358e968b5e077e6040f197d36ea6c169">Transform::m_rotation</a></div><div class="ttdeci">ref Quaternion m_rotation</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00018">transform.c:18</a></div></div>
<div class="ttc" id="aclass_transform_html_a3a696ae6c5b78970e4d13c0b693f20b7"><div class="ttname"><a href="../../dd/db7/class_transform.html#a3a696ae6c5b78970e4d13c0b693f20b7">Transform::Clone</a></div><div class="ttdeci">Transform Clone()</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00032">transform.c:32</a></div></div>
<div class="ttc" id="aclass_transform_html_a3dde3f1d2b1f62d2e163d399952be7dc"><div class="ttname"><a href="../../dd/db7/class_transform.html#a3dde3f1d2b1f62d2e163d399952be7dc">Transform::Add</a></div><div class="ttdeci">Transform Add(Transform transform)</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00051">transform.c:51</a></div></div>
<div class="ttc" id="aclass_transform_html_a3f2bc6009877be0f8a03c500f1732e49"><div class="ttname"><a href="../../dd/db7/class_transform.html#a3f2bc6009877be0f8a03c500f1732e49">Transform::Transform</a></div><div class="ttdeci">void Transform()</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00020">transform.c:20</a></div></div>
<div class="ttc" id="aclass_transform_html_a46bccab8937e4089b7ea674b2ca7d5a9"><div class="ttname"><a href="../../dd/db7/class_transform.html#a46bccab8937e4089b7ea674b2ca7d5a9">Transform::Set</a></div><div class="ttdeci">Transform Set(notnull Object obj, bool update=false)</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00071">transform.c:71</a></div></div>
<div class="ttc" id="aclass_transform_html_a4fc2ed0760e58284bde2bce512e3f5a9"><div class="ttname"><a href="../../dd/db7/class_transform.html#a4fc2ed0760e58284bde2bce512e3f5a9">Transform::SetRotation</a></div><div class="ttdeci">void SetRotation(Quaternion rotation)</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00186">transform.c:186</a></div></div>
<div class="ttc" id="aclass_transform_html_a53c66828897f63bf5519da52bda90b64"><div class="ttname"><a href="../../dd/db7/class_transform.html#a53c66828897f63bf5519da52bda90b64">Transform::DirectionAndUp</a></div><div class="ttdeci">static void DirectionAndUp(vector dir, vector up, out Transform trans, vector pos=&quot;0 0 0&quot;)</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00209">transform.c:209</a></div></div>
<div class="ttc" id="aclass_transform_html_a5b3ebf5f6efdd1e5d668fdefe84cdb16"><div class="ttname"><a href="../../dd/db7/class_transform.html#a5b3ebf5f6efdd1e5d668fdefe84cdb16">Transform::UpdateBasis</a></div><div class="ttdeci">void UpdateBasis()</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00141">transform.c:141</a></div></div>
<div class="ttc" id="aclass_transform_html_a6693b4561288db5578eff106112cb5a4"><div class="ttname"><a href="../../dd/db7/class_transform.html#a6693b4561288db5578eff106112cb5a4">Transform::GetOrigin</a></div><div class="ttdeci">vector GetOrigin()</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00199">transform.c:199</a></div></div>
<div class="ttc" id="aclass_transform_html_a73ebc268bc3bc7f6174e80a62775f601"><div class="ttname"><a href="../../dd/db7/class_transform.html#a73ebc268bc3bc7f6174e80a62775f601">Transform::GetRotation</a></div><div class="ttdeci">Quaternion GetRotation()</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00181">transform.c:181</a></div></div>
<div class="ttc" id="aclass_transform_html_a74e3f86d689a8642ca78cff6fc852bfe"><div class="ttname"><a href="../../dd/db7/class_transform.html#a74e3f86d689a8642ca78cff6fc852bfe">Transform::Multiply</a></div><div class="ttdeci">Transform Multiply(Transform m)</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00244">transform.c:244</a></div></div>
<div class="ttc" id="aclass_transform_html_a76414760f23ef03d6a251caceef7d656"><div class="ttname"><a href="../../dd/db7/class_transform.html#a76414760f23ef03d6a251caceef7d656">Transform::SetOrigin</a></div><div class="ttdeci">void SetOrigin(vector origin)</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00204">transform.c:204</a></div></div>
<div class="ttc" id="aclass_transform_html_a81b0992739cfbe2a00f136664688fe81"><div class="ttname"><a href="../../dd/db7/class_transform.html#a81b0992739cfbe2a00f136664688fe81">Transform::Set</a></div><div class="ttdeci">void Set(int _index, vector _value)</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00056">transform.c:56</a></div></div>
<div class="ttc" id="aclass_transform_html_a89f6d9f8e5feea833d901f2699e4beef"><div class="ttname"><a href="../../dd/db7/class_transform.html#a89f6d9f8e5feea833d901f2699e4beef">Transform::UpdateRotation</a></div><div class="ttdeci">void UpdateRotation()</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00150">transform.c:150</a></div></div>
<div class="ttc" id="aclass_transform_html_a9a939488083d62cd09a23880ed43e469"><div class="ttname"><a href="../../dd/db7/class_transform.html#a9a939488083d62cd09a23880ed43e469">Transform::GetBasis</a></div><div class="ttdeci">Matrix3 GetBasis()</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00168">transform.c:168</a></div></div>
<div class="ttc" id="aclass_transform_html_a9bc87107e6cf255408295398d6c3f188"><div class="ttname"><a href="../../dd/db7/class_transform.html#a9bc87107e6cf255408295398d6c3f188">Transform::Set</a></div><div class="ttdeci">void Set(int _index, string _value)</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00061">transform.c:61</a></div></div>
<div class="ttc" id="aclass_transform_html_a9d0855fac958b2f492a19eb9c54b6d46"><div class="ttname"><a href="../../dd/db7/class_transform.html#a9d0855fac958b2f492a19eb9c54b6d46">Transform::m_basis</a></div><div class="ttdeci">ref Matrix3 m_basis</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00017">transform.c:17</a></div></div>
<div class="ttc" id="aclass_transform_html_aa2522dc780d64c32197f11d1fb65005a"><div class="ttname"><a href="../../dd/db7/class_transform.html#aa2522dc780d64c32197f11d1fb65005a">Transform::GetYawPitchRoll</a></div><div class="ttdeci">vector GetYawPitchRoll()</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00194">transform.c:194</a></div></div>
<div class="ttc" id="aclass_transform_html_ac0dccb98fbf4d9093c48c3338dbeaa06"><div class="ttname"><a href="../../dd/db7/class_transform.html#ac0dccb98fbf4d9093c48c3338dbeaa06">Transform::GetPlayerBoneWS</a></div><div class="ttdeci">static Transform GetPlayerBoneWS(notnull Human human, int boneIdx, int mode=0)</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00115">transform.c:115</a></div></div>
<div class="ttc" id="aclass_transform_html_ac840f87478c54108bc21f037e677c724"><div class="ttname"><a href="../../dd/db7/class_transform.html#ac840f87478c54108bc21f037e677c724">Transform::SetBasis</a></div><div class="ttdeci">void SetBasis(Matrix3 basis)</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00173">transform.c:173</a></div></div>
<div class="ttc" id="aclass_transform_html_ad27fa76b54fc5628d6e132c8ec42e269"><div class="ttname"><a href="../../dd/db7/class_transform.html#ad27fa76b54fc5628d6e132c8ec42e269">Transform::Get</a></div><div class="ttdeci">Transform Get(notnull Object obj)</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00083">transform.c:83</a></div></div>
<div class="ttc" id="aclass_transform_html_ae8acbadb0be0e88d11577d8695718010"><div class="ttname"><a href="../../dd/db7/class_transform.html#ae8acbadb0be0e88d11577d8695718010">Transform::InvMultiply</a></div><div class="ttdeci">Transform InvMultiply(Transform m)</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00253">transform.c:253</a></div></div>
<div class="ttc" id="aclass_transform_html_aebb00b9320f0d25f374dc4612472fb67"><div class="ttname"><a href="../../dd/db7/class_transform.html#aebb00b9320f0d25f374dc4612472fb67">Transform::GetArray</a></div><div class="ttdeci">static Transform GetArray(vector trans[4])</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00092">transform.c:92</a></div></div>
<div class="ttc" id="aclass_transform_html_af117f62de54fcf14f7fe0c1c2e1a02dc"><div class="ttname"><a href="../../dd/db7/class_transform.html#af117f62de54fcf14f7fe0c1c2e1a02dc">Transform::data</a></div><div class="ttdeci">vector data[4]</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00015">transform.c:15</a></div></div>
<div class="ttc" id="aclass_transform_html_af474b26ca40a8835eeff58cebc300ca7"><div class="ttname"><a href="../../dd/db7/class_transform.html#af474b26ca40a8835eeff58cebc300ca7">Transform::YawPitchRoll</a></div><div class="ttdeci">static Transform YawPitchRoll(vector ypr, vector pos=&quot;0 0 0&quot;)</div><div class="ttdef"><b>Definition:</b> <a href="../../d8/d27/transform_8c_source.html#l00231">transform.c:231</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_6127fff2da0a20e2dc2cd9302c584350.html">DayzExpansion</a></li><li class="navelem"><a class="el" href="../../dir_fa1f4f079ed95106cba6603012ba90d8.html">Core</a></li><li class="navelem"><a class="el" href="../../dir_4763e2204ca4935d3e08fff4ec8c41d9.html">Scripts</a></li><li class="navelem"><a class="el" href="../../dir_f7c621fee0a2c32a175ba0589ac46b9f.html">3_game</a></li><li class="navelem"><a class="el" href="../../dir_9ddfc87c5f9b9fe1ae81092761181e6d.html">dayzexpansion_core</a></li><li class="navelem"><a class="el" href="../../dir_7e09f36e26b2f663af36ec1f2c2fe1df.html">math</a></li><li class="navelem"><a class="el" href="../../d8/d27/transform_8c.html">transform.c</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.5 </li>
  </ul>
</div>
</body>
</html>
